Index: applications/editors/josm/plugins/sds/build.xml
===================================================================
--- applications/editors/josm/plugins/sds/build.xml	(revision 29853)
+++ applications/editors/josm/plugins/sds/build.xml	(revision 29854)
@@ -5,5 +5,5 @@
     <property name="commit.message" value=""/>
     <!-- enter the *lowest* JOSM version this plugin is currently compatible with -->
-    <property name="plugin.main.version" value="6088"/>
+    <property name="plugin.main.version" value="6162"/>
 
     <!--
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsConnection.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsConnection.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsConnection.java	(revision 29854)
@@ -2,6 +2,6 @@
 package org.openstreetmap.hot.sds;
 
+import java.net.Authenticator.RequestorType;
 import java.net.HttpURLConnection;
-import java.net.Authenticator.RequestorType;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsCredentialAgent.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsCredentialAgent.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsCredentialAgent.java	(revision 29854)
@@ -5,8 +5,8 @@
 
 import java.awt.Component;
+import java.net.Authenticator.RequestorType;
 import java.net.PasswordAuthentication;
-import java.net.Authenticator.RequestorType;
+import java.util.HashMap;
 import java.util.Map;
-import java.util.HashMap;
 
 import javax.swing.text.html.HTMLEditorKit;
@@ -18,4 +18,5 @@
 import org.openstreetmap.josm.gui.widgets.HtmlPanel;
 import org.openstreetmap.josm.io.auth.AbstractCredentialsAgent;
+import org.openstreetmap.josm.io.auth.CredentialsAgent;
 import org.openstreetmap.josm.io.auth.CredentialsAgentException;
 import org.openstreetmap.josm.io.auth.CredentialsAgentResponse;
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsDiskAccessAction.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsDiskAccessAction.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsDiskAccessAction.java	(revision 29854)
@@ -10,5 +10,4 @@
 import org.openstreetmap.josm.Main;
 import org.openstreetmap.josm.actions.DiskAccessAction;
-import org.openstreetmap.josm.actions.ExtensionFileFilter;
 import org.openstreetmap.josm.gui.ExtendedDialog;
 import org.openstreetmap.josm.tools.Shortcut;
@@ -96,5 +95,4 @@
 
         File file = fc.getSelectedFile();
-        String fn = file.getPath();
 
         if (!confirmOverwrite(file))
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsLoadAction.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsLoadAction.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsLoadAction.java	(revision 29854)
@@ -5,5 +5,4 @@
 
 import java.awt.event.ActionEvent;
-import java.awt.event.KeyEvent;
 import java.io.File;
 import java.io.FileInputStream;
@@ -16,14 +15,10 @@
 
 import javax.swing.JFileChooser;
-import javax.swing.filechooser.FileFilter;
 import javax.xml.parsers.ParserConfigurationException;
 import javax.xml.parsers.SAXParserFactory;
 
 import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.actions.DiskAccessAction;
-import org.openstreetmap.josm.gui.ExtendedDialog;
 import org.openstreetmap.josm.gui.PleaseWaitRunnable;
 import org.openstreetmap.josm.io.OsmTransferException;
-import org.openstreetmap.josm.tools.Shortcut;
 import org.xml.sax.InputSource;
 import org.xml.sax.SAXException;
@@ -34,8 +29,6 @@
 	private SeparateDataStorePlugin plugin;
 
-    @SuppressWarnings("deprecation")
-	public SdsLoadAction(SeparateDataStorePlugin p) {
-        super(tr("Load..."), "sds_load", tr("Load separate data store data from a file."),
-            null);
+    public SdsLoadAction(SeparateDataStorePlugin p) {
+        super(tr("Load..."), "sds_load", tr("Load separate data store data from a file."), null);
     	plugin = p;
     }
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsMenu.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsMenu.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsMenu.java	(revision 29854)
@@ -12,5 +12,4 @@
 
 import javax.swing.BorderFactory;
-import javax.swing.JLabel;
 import javax.swing.JMenu;
 import javax.swing.JMenuItem;
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsSaveAction.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsSaveAction.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/SdsSaveAction.java	(revision 29854)
@@ -5,5 +5,4 @@
 
 import java.awt.event.ActionEvent;
-import java.awt.event.KeyEvent;
 import java.io.File;
 import java.io.FileInputStream;
@@ -16,21 +15,15 @@
 import java.io.Writer;
 
-import javax.swing.JFileChooser;
 import javax.swing.JOptionPane;
-import javax.swing.filechooser.FileFilter;
 
 import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.actions.SaveActionBase;
 import org.openstreetmap.josm.data.osm.IPrimitive;
-import org.openstreetmap.josm.gui.ExtendedDialog;
 import org.openstreetmap.josm.gui.layer.Layer;
 import org.openstreetmap.josm.gui.layer.OsmDataLayer;
-import org.openstreetmap.josm.tools.Shortcut;
 
 @SuppressWarnings("serial")
 public class SdsSaveAction extends SdsDiskAccessAction {
 
-    @SuppressWarnings("deprecation")
-	public SdsSaveAction() {
+    public SdsSaveAction() {
         super(tr("Save..."), "sds_save", tr("Save the current separate data store information to a file."),
             null);
Index: applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/WritePostprocessor.java
===================================================================
--- applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/WritePostprocessor.java	(revision 29853)
+++ applications/editors/josm/plugins/sds/src/org/openstreetmap/hot/sds/WritePostprocessor.java	(revision 29854)
@@ -55,4 +55,6 @@
 		}
 		
+		sdsWriter.close();
+		
 		for (IPrimitive p : primitives) {
 			plugin.learn(p);