Index: applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/api/NewAction.java
===================================================================
--- applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/api/NewAction.java	(revision 29934)
+++ 	(revision )
@@ -1,86 +1,0 @@
-/* Copyright (c) 2008, Henrik Niehaus
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * 1. Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- * 3. Neither the name of the project nor the names of its
- *    contributors may be used to endorse or promote products derived from this
- *    software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-package org.openstreetmap.josm.plugins.osb.api;
-
-import static org.openstreetmap.josm.tools.I18n.tr;
-
-import java.awt.Point;
-import java.io.IOException;
-import java.net.URLEncoder;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
-
-import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.data.coor.LatLon;
-import org.openstreetmap.josm.data.osm.Node;
-import org.openstreetmap.josm.plugins.osb.ConfigKeys;
-import org.openstreetmap.josm.plugins.osb.api.util.HttpUtils;
-
-public class NewAction {
-
-    private final String CHARSET = "UTF-8";
-
-    public Node execute(Point p, String text) throws IOException {
-        // where has the issue been added
-        LatLon latlon = Main.map.mapView.getLatLon(p.x, p.y);
-
-        // create the URI for the data download
-        String uri = Main.pref.get(ConfigKeys.OSB_API_URI_NEW);
-
-        String post = new StringBuilder("lon=")
-            .append(latlon.lon())
-            .append("&lat=")
-            .append(latlon.lat())
-            .append("&text=")
-            .append(URLEncoder.encode(text, CHARSET))
-            .toString();
-
-        String result = null;
-        if(Main.pref.getBoolean(ConfigKeys.OSB_API_DISABLED)) {
-            result = "ok 12345";
-        } else {
-            result = HttpUtils.post(uri, post, CHARSET);
-        }
-
-        Pattern resultPattern = Pattern.compile("ok\\s+(\\d+)\\s*");
-        Matcher m = resultPattern.matcher(result);
-        String id = "-1";
-        if(m.matches()) {
-            id = m.group(1);
-        } else {
-            throw new RuntimeException(tr("Couldn''t create new bug. Result: {0}", result));
-        }
-
-        Node osmNode = new Node(latlon);
-        osmNode.put("id", id);
-        osmNode.put("note", text);
-        osmNode.put("openstreetbug", "FIXME");
-        osmNode.put("state", "0");
-        return osmNode;
-    }
-}
Index: applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbDialog.java
===================================================================
--- applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbDialog.java	(revision 29934)
+++ applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbDialog.java	(revision 30004)
@@ -83,5 +83,4 @@
 import org.openstreetmap.josm.plugins.osb.gui.action.OsbAction;
 import org.openstreetmap.josm.plugins.osb.gui.action.OsbActionObserver;
-import org.openstreetmap.josm.plugins.osb.gui.action.PointToNewIssueAction;
 import org.openstreetmap.josm.plugins.osb.gui.action.PopupFactory;
 import org.openstreetmap.josm.plugins.osb.gui.action.ToggleConnectionModeAction;
@@ -103,5 +102,4 @@
     private JButton closeIssue;
     private JButton processQueue = new JButton(tr("Process queue"));
-    private JToggleButton newIssue = new JToggleButton();
     private JToggleButton toggleConnectionMode;
     private JTabbedPane tabbedPane = new JTabbedPane();
@@ -174,12 +172,7 @@
         closeIssue.setToolTipText((String) closeIssue.getAction().getValue(Action.NAME));
         closeIssue.setIcon(OsbPlugin.loadIcon("icon_valid22.png"));
-        PointToNewIssueAction nia = new PointToNewIssueAction(newIssue, osbPlugin);
-        newIssue.setAction(nia);
-        newIssue.setToolTipText((String) newIssue.getAction().getValue(Action.NAME));
-        newIssue.setIcon(OsbPlugin.loadIcon("icon_error_add22.png"));
 
         buttonPanel.add(toggleConnectionMode);
         buttonPanel.add(refresh);
-        buttonPanel.add(newIssue);
         buttonPanel.add(addComment);
         buttonPanel.add(closeIssue);
@@ -215,5 +208,4 @@
             addComment.setHorizontalAlignment(SwingConstants.LEFT);
             closeIssue.setHorizontalAlignment(SwingConstants.LEFT);
-            newIssue.setHorizontalAlignment(SwingConstants.LEFT);
         } else {
             toggleConnectionMode.setText(null);
@@ -221,5 +213,4 @@
             addComment.setText(null);
             closeIssue.setText(null);
-            newIssue.setText(null);
         }
 
@@ -227,5 +218,4 @@
         closeIssueAction.addActionObserver(this);
         setConnectionMode(offline);
-
 
         MapView.addLayerChangeListener(this);
Index: applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbQueueListCellRenderer.java
===================================================================
--- applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbQueueListCellRenderer.java	(revision 29934)
+++ applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/OsbQueueListCellRenderer.java	(revision 30004)
@@ -41,5 +41,4 @@
 import org.openstreetmap.josm.plugins.osb.gui.action.AddCommentAction;
 import org.openstreetmap.josm.plugins.osb.gui.action.CloseIssueAction;
-import org.openstreetmap.josm.plugins.osb.gui.action.NewIssueAction;
 import org.openstreetmap.josm.plugins.osb.gui.action.OsbAction;
 
@@ -65,7 +64,5 @@
         OsbAction action = (OsbAction) value;
         Icon icon = null;
-        if(action instanceof NewIssueAction) {
-            icon = OsbPlugin.loadIcon("icon_error_add16.png");
-        } else if(action instanceof AddCommentAction) {
+        if(action instanceof AddCommentAction) {
             icon = OsbPlugin.loadIcon("add_comment16.png");
         } else if(action instanceof CloseIssueAction) {
@@ -85,4 +82,3 @@
         return label;
     }
-
 }
Index: applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/action/NewIssueAction.java
===================================================================
--- applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/action/NewIssueAction.java	(revision 29934)
+++ 	(revision )
@@ -1,112 +1,0 @@
-/* Copyright (c) 2008, Henrik Niehaus
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * 1. Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- * 3. Neither the name of the project nor the names of its
- *    contributors may be used to endorse or promote products derived from this
- *    software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-package org.openstreetmap.josm.plugins.osb.gui.action;
-
-import static org.openstreetmap.josm.tools.I18n.tr;
-
-import java.awt.Point;
-import java.awt.event.ActionEvent;
-import java.io.IOException;
-import java.util.LinkedList;
-import java.util.List;
-
-import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.data.osm.Node;
-import org.openstreetmap.josm.gui.widgets.HistoryChangedListener;
-import org.openstreetmap.josm.plugins.osb.ConfigKeys;
-import org.openstreetmap.josm.plugins.osb.OsbPlugin;
-import org.openstreetmap.josm.plugins.osb.api.NewAction;
-import org.openstreetmap.josm.plugins.osb.gui.dialogs.TextInputDialog;
-
-public class NewIssueAction extends OsbAction {
-
-    private static final long serialVersionUID = 1L;
-
-    private OsbPlugin plugin;
-
-    private String result;
-
-    private Point p;
-
-    private NewAction newAction = new NewAction();
-
-    public NewIssueAction(OsbPlugin plugin, Point p) {
-        super(tr("New issue"), plugin.getDialog());
-        this.plugin = plugin;
-        this.p = p;
-    }
-
-    @Override
-    protected void doActionPerformed(ActionEvent e) throws IOException, InterruptedException {
-        List<String> history = new LinkedList<String>(Main.pref.getCollection(ConfigKeys.OSB_NEW_HISTORY, new LinkedList<String>()));
-        HistoryChangedListener l = new HistoryChangedListener() {
-            public void historyChanged(List<String> history) {
-                Main.pref.putCollection(ConfigKeys.OSB_NEW_HISTORY, history);
-            }
-        };
-
-        result = TextInputDialog.showDialog(
-                Main.map,
-                tr("Create issue"),
-                tr("Describe the problem precisely"),
-                OsbPlugin.loadIcon("icon_error_add22.png"),
-                history, l);
-
-        if(result == null) {
-            canceled = true;
-        }
-    }
-
-    @Override
-    public void execute() throws IOException {
-        if (result.length() > 0) {
-            result = addMesgInfo(result);
-            Node n = newAction.execute(p, result);
-            plugin.getDataSet().addPrimitive(n);
-            if (Main.pref.getBoolean(ConfigKeys.OSB_API_DISABLED)) {
-                plugin.updateGui();
-            } else {
-                plugin.updateData();
-            }
-        }
-    }
-
-    @Override
-    public String toString() {
-        return tr("Create: " + result);
-    }
-
-    @Override
-    public OsbAction clone() {
-        NewIssueAction action = new NewIssueAction(plugin, p);
-        action.canceled = canceled;
-        action.p = p;
-        action.result = result;
-        return action;
-    }
-}
Index: applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/action/PointToNewIssueAction.java
===================================================================
--- applications/editors/josm/plugins/openstreetbugs/src/org/openstreetmap/josm/plugins/osb/gui/action/PointToNewIssueAction.java	(revision 29934)
+++ 	(revision )
@@ -1,94 +1,0 @@
-/* Copyright (c) 2008, Henrik Niehaus
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * 1. Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- * 3. Neither the name of the project nor the names of its
- *    contributors may be used to endorse or promote products derived from this
- *    software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-package org.openstreetmap.josm.plugins.osb.gui.action;
-
-import static org.openstreetmap.josm.tools.I18n.tr;
-
-import java.awt.Cursor;
-import java.awt.event.ActionEvent;
-import java.awt.event.MouseEvent;
-import java.awt.event.MouseListener;
-
-import javax.swing.AbstractAction;
-import javax.swing.JToggleButton;
-
-import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.plugins.osb.OsbPlugin;
-
-public class PointToNewIssueAction extends AbstractAction implements MouseListener {
-
-    private static final long serialVersionUID = 1L;
-
-    private JToggleButton button;
-
-    private OsbPlugin plugin;
-
-    private Cursor previousCursor;
-
-    public PointToNewIssueAction(JToggleButton button, OsbPlugin plugin) {
-        super(tr("New issue"));
-        this.button = button;
-        this.plugin = plugin;
-    }
-
-    private void reset() {
-        Main.map.mapView.setCursor(previousCursor);
-        Main.map.mapView.removeMouseListener(this);
-        button.setSelected(false);
-    }
-
-    public void mouseClicked(MouseEvent e) {
-        addNewIssue(e);
-    }
-
-    public void mouseEntered(MouseEvent e) {}
-
-    public void mouseExited(MouseEvent e) {}
-
-    public void mousePressed(MouseEvent e) {
-        addNewIssue(e);
-    }
-
-    private void addNewIssue(MouseEvent e) {
-        NewIssueAction nia = new NewIssueAction(plugin, e.getPoint());
-        nia.actionPerformed(new ActionEvent(this, 0, ""));
-        reset();
-    }
-
-    public void mouseReleased(MouseEvent e) {}
-
-    public void actionPerformed(ActionEvent e) {
-        if(button.isSelected()) {
-            previousCursor = Main.map.mapView.getCursor();
-            Main.map.mapView.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
-            Main.map.mapView.addMouseListener(this);
-        } else {
-            reset();
-        }
-    }
-}